
const
  Rl = 0;
  Im = 1;

type
  Complex = Array[Rl..Im] of Real;

procedure WriteComplex(A: Complex; i,j: Integer);
begin {of procedure WriteComplex}
Write(A[Rl]:i:j,' + ',A[Im]:i:j,'i');
end; {of procedure WriteComplex}

procedure WriteLnComplex(A: Complex; i,j: Integer);
begin {of procedure WriteLnComplex}
WriteComplex(A,i,j);
WriteLn;
end; {of procedure WriteLnComplex}

procedure AssignComplex(A: Complex; var B: Complex);
begin {of procedure AssignComplex}
B[Rl] := A[Rl];
B[Im] := A[Im];
end; {of procedure AssignComplex}

procedure AddComplex(A,B: Complex; var C: Complex);
begin {of procedure AddComplex}
C[Rl] := A[Rl] + B[Rl];
C[Im] := A[Im] + B[Im];
end; {of procedure AddComplex}

procedure SubtComplex(A,B: Complex; var C: Complex);
begin {of procedure SubtComplex}
C[Rl] := A[Rl] - B[Rl];
C[Im] := A[Im] - B[Im];
end; {of procedure SubtComplex}

procedure MultComplex(A,B: Complex; var C: Complex);
begin {of procedure MultComplex}
C[Rl] := A[Rl]*B[Rl] - A[Im]*B[Im];
C[Im] := A[Rl]*B[Im] + A[Im]*B[Rl];
end; {of procedure MultComplex}

procedure DivComplex(A,B: Complex; var C: Complex);
var X : Real;
begin {of procedure DivComplex}
X := Sqr(B[Rl])+Sqr(B[Im]);
C[Rl] := (A[Rl]*B[Rl]+A[Im]*B[Im])/X;
C[Im] := (A[Im]*B[Rl]-A[Rl]*B[Im])/X;
end; {of procedure DivComplex}

procedure InvComplex(A: Complex; var C: Complex);
var X : Real;
begin {of procedure InvComplex}
X := Sqr(A[Rl])+Sqr(A[Im]);
C[Rl] := A[Rl]/X;
C[Im] := -A[Im]/X;
end; {of procedure InvComplex}

(* --> this procedure requires function Power <--
procedure PowerComplex(A: Complex; X: Real; var C: Complex);
begin {of procedure PowerComplex}
end; {of procedure PowerComplex}
*)

procedure SqrtComplex(A: Complex; var C: Complex);
var R,T : Real;
begin {of procedure SqrtComplex}
R := Sqrt(Sqr(A[Rl])+Sqr(A[Im]));
if A[Rl] = 0.0 then
  begin
  if A[Im] >= 0.0
  then T := Pi/2.0
  else T := -Pi/2.0
  end
else if A[Im] = 0.0 then
  begin
  if A[Rl] >= 0.0
  then T := 0.0
  else T := Pi
  end
else
  begin
  if (A[Rl]>0.0) and (A[Im]>0.0) then T := ArcTan(A[Im]/A[Rl])
  else if (A[Rl]>0.0) and (A[Im]<0.0) then T := ArcTan(A[Im]/A[Rl])
  else if (A[Rl]<0.0) and (A[Im]<0.0) then T := ArcTan(A[Im]/A[Rl]) - Pi
  else if (A[Rl]<0.0) and (A[Im]>0.0) then T := ArcTan(A[Im]/A[Rl]) + Pi;
  end;
R := Sqrt(R);
T := 0.5*T;
C[Rl] := R*Cos(T);
C[Im] := R*Sin(T);
end; {of procedure SqrtComplex}
