
procedure DirectoryList(FilePathMask : String80);
{
       This is a simple procedure to list out the directory of the
       path specified by mask; global search characters (?,*)
       may be included.  A type declaration of String80 = string[80]
       is required for FilePathMask (or turn off parameter checking).
}
type
  Char80arr            = array [ 1..80 ] of Char;
  String20             = string[ 20 ];

var
  Regs                 : Registers;
  DTA                  : array [ 1..43 ] of Byte;
  Mask                 : Char80arr;
  NamR                 : String20;
  Error, I, J, dotpos  : Integer;

procedure WriteFileName;
begin
dotpos := pos('.',NamR);
if dotpos = 0
then begin
  write(NamR);
  write('':16-length(NamR))
  end
else begin
  write(copy(NamR,1,dotpos-1));
  write('':9-dotpos);
  write('.');
  write(copy(NamR,dotpos+1,length(NamR)));
  write('':16-length(NamR)-(9-dotpos));
  end;
J := J + 1;
end;

begin {of DirectoryList}

  FillChar(DTA,SizeOf(DTA),0);        { Initialize the DTA buffer }
  FillChar(Mask,SizeOf(Mask),0);      { Initialize the mask }
  FillChar(NamR,SizeOf(NamR),0);      { Initialize the file name }
  J := 0;                             { Initialize file counter}

  if length(FilePathMask) <> 0
  then for I := 1 to length(FilePathMask) do   { Assign FilePathMask to Mask }
         Mask[I] := FilePathMask[i]
  else begin
         Mask[1] := '*';              { if no FilePathMask is specified }
         Mask[2] := '.';              { assign *.* to Mask }
         Mask[3] := '*'
       end;

  Regs.AX := $1A00;         { Function used to set the DTA }
  Regs.DS := Seg(DTA);      { store the parameter segment in DS }
  Regs.DX := Ofs(DTA);      {   "    "      "     offset in DX }
  MSDos(Regs);              { Set DTA location }
  Error := 0;
  Regs.AX := $4E00;          { Get first directory entry }
  Regs.DS := Seg(Mask);      { Point to the file Mask }
  Regs.DX := Ofs(Mask);
  Regs.CX := 1;             { Store the option }
  MSDos(Regs);               { Execute MSDos call }
  Error := Regs.AX and $FF;  { Get Error return }
  I := 1;                    { initialize 'I' to the first element }
  if (Error = 0) then
    repeat
      NamR[I] := Chr(Mem[Seg(DTA):Ofs(DTA)+29+I]);
      I := I + 1;
    until not (NamR[I-1] in [' '..'~']) or (I>20);

  NamR[0] := Chr(I-1);          { set string length because assigning }
                                { by element does not set length }
  if (Error = 0) then WriteFileName;
  while (Error = 0) do begin
    Error := 0;
    Regs.AX := $4F00;           { Function used to get the next }
                                { directory entry }
    Regs.CX := 1;               { Set the file option }
    MSDos( Regs );              { Call MSDos }
    Error := Regs.AX and $FF;   { get the Error return }
    I := 1;
    repeat
      NamR[I] := Chr(Mem[Seg(DTA):Ofs(DTA)+29+I]);
      I := I + 1;
    until not (NamR[I-1] in [' '..'~'] ) or (I > 20);
    NamR[0] := Chr(I-1);
    if (Error = 0) then WriteFileName  { Print formatted filename.ext }
  end;
if J mod 5 <> 0 then WriteLn;   { add a final CR unless provided already }
end; { of procedure DirectoryList  }
